Index: uspace/lib/c/include/ipc/ipc.h
===================================================================
--- uspace/lib/c/include/ipc/ipc.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/ipc/ipc.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -44,8 +44,9 @@
 #include <abi/synch.h>
 #include <abi/proc/task.h>
+#include <abi/cap.h>
 
 typedef void (*ipc_async_callback_t)(void *, int, ipc_call_t *);
 
-extern ipc_callid_t ipc_wait_cycle(ipc_call_t *, sysarg_t, unsigned int);
+extern int ipc_wait_cycle(ipc_call_t *, sysarg_t, unsigned int);
 extern void ipc_poke(void);
 
@@ -53,6 +54,6 @@
 	ipc_wait_for_call_timeout(data, SYNCH_NO_TIMEOUT);
 
-extern ipc_callid_t ipc_wait_for_call_timeout(ipc_call_t *, sysarg_t);
-extern ipc_callid_t ipc_trywait_for_call(ipc_call_t *);
+extern int ipc_wait_for_call_timeout(ipc_call_t *, sysarg_t);
+extern int ipc_trywait_for_call(ipc_call_t *);
 
 /*
@@ -63,20 +64,21 @@
  */
 
-#define ipc_answer_0(callid, retval) \
-	ipc_answer_fast((callid), (retval), 0, 0, 0, 0)
-#define ipc_answer_1(callid, retval, arg1) \
-	ipc_answer_fast((callid), (retval), (arg1), 0, 0, 0)
-#define ipc_answer_2(callid, retval, arg1, arg2) \
-	ipc_answer_fast((callid), (retval), (arg1), (arg2), 0, 0)
-#define ipc_answer_3(callid, retval, arg1, arg2, arg3) \
-	ipc_answer_fast((callid), (retval), (arg1), (arg2), (arg3), 0)
-#define ipc_answer_4(callid, retval, arg1, arg2, arg3, arg4) \
-	ipc_answer_fast((callid), (retval), (arg1), (arg2), (arg3), (arg4))
-#define ipc_answer_5(callid, retval, arg1, arg2, arg3, arg4, arg5) \
-	ipc_answer_slow((callid), (retval), (arg1), (arg2), (arg3), (arg4), (arg5))
+#define ipc_answer_0(chandle, retval) \
+	ipc_answer_fast((chandle), (retval), 0, 0, 0, 0)
+#define ipc_answer_1(chandle, retval, arg1) \
+	ipc_answer_fast((chandle), (retval), (arg1), 0, 0, 0)
+#define ipc_answer_2(chandle, retval, arg1, arg2) \
+	ipc_answer_fast((chandle), (retval), (arg1), (arg2), 0, 0)
+#define ipc_answer_3(chandle, retval, arg1, arg2, arg3) \
+	ipc_answer_fast((chandle), (retval), (arg1), (arg2), (arg3), 0)
+#define ipc_answer_4(chandle, retval, arg1, arg2, arg3, arg4) \
+	ipc_answer_fast((chandle), (retval), (arg1), (arg2), (arg3), (arg4))
+#define ipc_answer_5(chandle, retval, arg1, arg2, arg3, arg4, arg5) \
+	ipc_answer_slow((chandle), (retval), (arg1), (arg2), (arg3), (arg4), \
+	    (arg5))
 
-extern sysarg_t ipc_answer_fast(ipc_callid_t, sysarg_t, sysarg_t, sysarg_t,
+extern sysarg_t ipc_answer_fast(cap_handle_t, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t);
-extern sysarg_t ipc_answer_slow(ipc_callid_t, sysarg_t, sysarg_t, sysarg_t,
+extern sysarg_t ipc_answer_slow(cap_handle_t, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t, sysarg_t);
 
@@ -88,38 +90,37 @@
  */
 
-#define ipc_call_async_0(phoneid, method, private, callback) \
-	ipc_call_async_fast((phoneid), (method), 0, 0, 0, 0, (private), \
+#define ipc_call_async_0(phandle, method, private, callback) \
+	ipc_call_async_fast((phandle), (method), 0, 0, 0, (private), (callback))
+#define ipc_call_async_1(phandle, method, arg1, private, callback) \
+	ipc_call_async_fast((phandle), (method), (arg1), 0, 0, (private), \
 	    (callback))
-#define ipc_call_async_1(phoneid, method, arg1, private, callback) \
-	ipc_call_async_fast((phoneid), (method), (arg1), 0, 0, 0, (private), \
-	    (callback))
-#define ipc_call_async_2(phoneid, method, arg1, arg2, private, callback) \
-	ipc_call_async_fast((phoneid), (method), (arg1), (arg2), 0, 0, \
+#define ipc_call_async_2(phandle, method, arg1, arg2, private, callback) \
+	ipc_call_async_fast((phandle), (method), (arg1), (arg2), 0, \
 	    (private), (callback))
-#define ipc_call_async_3(phoneid, method, arg1, arg2, arg3, private, callback) \
-	ipc_call_async_fast((phoneid), (method), (arg1), (arg2), (arg3), 0, \
+#define ipc_call_async_3(phandle, method, arg1, arg2, arg3, private, callback) \
+	ipc_call_async_fast((phandle), (method), (arg1), (arg2), (arg3), \
 	    (private), (callback))
-#define ipc_call_async_4(phoneid, method, arg1, arg2, arg3, arg4, private, \
+#define ipc_call_async_4(phandle, method, arg1, arg2, arg3, arg4, private, \
     callback) \
-	ipc_call_async_fast((phoneid), (method), (arg1), (arg2), (arg3), \
-	    (arg4), (private), (callback))
-#define ipc_call_async_5(phoneid, method, arg1, arg2, arg3, arg4, arg5, \
+	ipc_call_async_slow((phandle), (method), (arg1), (arg2), (arg3), \
+	    (arg4), 0, (private), (callback))
+#define ipc_call_async_5(phandle, method, arg1, arg2, arg3, arg4, arg5, \
     private, callback) \
-	ipc_call_async_slow((phoneid), (method), (arg1), (arg2), (arg3), \
+	ipc_call_async_slow((phandle), (method), (arg1), (arg2), (arg3), \
 	    (arg4), (arg5), (private), (callback))
 
-extern void ipc_call_async_fast(int, sysarg_t, sysarg_t, sysarg_t, sysarg_t,
+extern void ipc_call_async_fast(cap_handle_t, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, void *, ipc_async_callback_t);
-extern void ipc_call_async_slow(int, sysarg_t, sysarg_t, sysarg_t, sysarg_t,
-    sysarg_t, sysarg_t, void *, ipc_async_callback_t);
+extern void ipc_call_async_slow(cap_handle_t, sysarg_t, sysarg_t, sysarg_t,
+    sysarg_t, sysarg_t, sysarg_t, void *, ipc_async_callback_t);
 
-extern int ipc_hangup(int);
+extern int ipc_hangup(cap_handle_t);
 
-extern int ipc_forward_fast(ipc_callid_t, int, sysarg_t, sysarg_t, sysarg_t,
-    unsigned int);
-extern int ipc_forward_slow(ipc_callid_t, int, sysarg_t, sysarg_t, sysarg_t,
-    sysarg_t, sysarg_t, sysarg_t, unsigned int);
+extern int ipc_forward_fast(cap_handle_t, cap_handle_t, sysarg_t, sysarg_t,
+    sysarg_t, unsigned int);
+extern int ipc_forward_slow(cap_handle_t, cap_handle_t, sysarg_t, sysarg_t,
+    sysarg_t, sysarg_t, sysarg_t, sysarg_t, unsigned int);
 
-extern int ipc_connect_kbox(task_id_t);
+extern int ipc_connect_kbox(task_id_t, cap_handle_t *);
 
 #endif
Index: uspace/lib/c/include/ipc/irq.h
===================================================================
--- uspace/lib/c/include/ipc/irq.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/ipc/irq.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -38,7 +38,8 @@
 #include <types/common.h>
 #include <abi/ddi/irq.h>
+#include <abi/cap.h>
 
-extern int ipc_irq_subscribe(int, sysarg_t, const irq_code_t *);
-extern int ipc_irq_unsubscribe(int);
+extern int ipc_irq_subscribe(int, sysarg_t, const irq_code_t *, cap_handle_t *);
+extern int ipc_irq_unsubscribe(cap_handle_t);
 
 #endif
Index: uspace/lib/c/include/ipc/serial_ctl.h
===================================================================
--- uspace/lib/c/include/ipc/serial_ctl.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/ipc/serial_ctl.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -30,5 +30,5 @@
 #define LIBC_IPC_SERIAL_CTL_H_
 
-#include <ipc/dev_iface.h>
+#include <ipc/chardev.h>
 
 /** IPC methods for getting/setting serial communication properties
@@ -41,5 +41,5 @@
  */
 typedef enum {
-	SERIAL_GET_COM_PROPS = DEV_FIRST_CUSTOM_METHOD,
+	SERIAL_GET_COM_PROPS = CHARDEV_LIMIT,
 	SERIAL_SET_COM_PROPS
 } serial_ctl_t;
Index: uspace/lib/c/include/ipc/services.h
===================================================================
--- uspace/lib/c/include/ipc/services.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/ipc/services.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -49,4 +49,7 @@
 } service_t;
 
+#define SERVICE_NAME_CHARDEV_TEST_SMALLX "chardev-test/smallx"
+#define SERVICE_NAME_CHARDEV_TEST_LARGEX "chardev-test/largex"
+#define SERVICE_NAME_CHARDEV_TEST_PARTIALX "chardev-test/partialx"
 #define SERVICE_NAME_CLIPBOARD "clipboard"
 #define SERVICE_NAME_CORECFG  "corecfg"
Index: uspace/lib/c/include/str_error.h
===================================================================
--- uspace/lib/c/include/str_error.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/str_error.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,5 +36,8 @@
 #define LIBC_STRERROR_H_
 
-const char *str_error(const int);
+#include <errno.h>
+
+const char *str_error(errno_t);
+const char *str_error_name(errno_t);
 
 #endif
Index: uspace/lib/c/include/vfs/vfs.h
===================================================================
--- uspace/lib/c/include/vfs/vfs.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/include/vfs/vfs.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -85,5 +85,5 @@
 
 extern char *vfs_absolutize(const char *, size_t *);
-extern int vfs_clone(int, int, bool);
+extern int vfs_clone(int, int, bool, int *);
 extern int vfs_cwd_get(char *path, size_t);
 extern int vfs_cwd_set(const char *path);
@@ -95,6 +95,6 @@
 extern int vfs_link(int, const char *, vfs_file_kind_t, int *);
 extern int vfs_link_path(const char *, vfs_file_kind_t, int *);
-extern int vfs_lookup(const char *, int);
-extern int vfs_lookup_open(const char *, int, int);
+extern int vfs_lookup(const char *, int, int *);
+extern int vfs_lookup_open(const char *, int, int, int *);
 extern int vfs_mount_path(const char *, const char *, const char *,
     const char *, unsigned int, unsigned int);
@@ -104,11 +104,11 @@
 extern int vfs_pass_handle(async_exch_t *, int, async_exch_t *);
 extern int vfs_put(int);
-extern ssize_t vfs_read(int, aoff64_t *, void *, size_t);
+extern int vfs_read(int, aoff64_t *, void *, size_t, size_t *);
 extern int vfs_read_short(int, aoff64_t, void *, size_t, ssize_t *);
-extern int vfs_receive_handle(bool);
+extern int vfs_receive_handle(bool, int *);
 extern int vfs_rename_path(const char *, const char *);
 extern int vfs_resize(int, aoff64_t);
 extern int vfs_root(void);
-extern void vfs_root_set(int);
+extern int vfs_root_set(int);
 extern int vfs_stat(int, struct stat *);
 extern int vfs_stat_path(const char *, struct stat *);
@@ -120,6 +120,6 @@
 extern int vfs_unmount(int);
 extern int vfs_unmount_path(const char *);
-extern int vfs_walk(int, const char *, int);
-extern ssize_t vfs_write(int, aoff64_t *, const void *, size_t);
+extern int vfs_walk(int, const char *, int, int *);
+extern int vfs_write(int, aoff64_t *, const void *, size_t, size_t *);
 extern int vfs_write_short(int, aoff64_t, const void *, size_t, ssize_t *);
 
Index: uspace/lib/c/test/adt/circ_buf.c
===================================================================
--- uspace/lib/c/test/adt/circ_buf.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
+++ uspace/lib/c/test/adt/circ_buf.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -0,0 +1,81 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <adt/circ_buf.h>
+#include <pcut/pcut.h>
+
+PCUT_INIT
+
+PCUT_TEST_SUITE(circ_buf);
+
+enum {
+	buffer_size = 16
+};
+
+static int buffer[buffer_size];
+
+/** Basic insertion/deletion test.
+ *
+ * Test initialization, emptiness, pushing buffer until it is full,
+ * then emptying it again.
+ */
+PCUT_TEST(push_pop)
+{
+	circ_buf_t cbuf;
+	int i;
+	int j;
+	int rc;
+
+	circ_buf_init(&cbuf, buffer, buffer_size, sizeof(int));
+
+	for (i = 0; i < buffer_size; i++) {
+		PCUT_ASSERT_INT_EQUALS(buffer_size - i, circ_buf_nfree(&cbuf));
+		PCUT_ASSERT_INT_EQUALS(i, circ_buf_nused(&cbuf));
+		rc = circ_buf_push(&cbuf, &i);
+		PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	}
+
+	rc = circ_buf_push(&cbuf, &i);
+	PCUT_ASSERT_ERRNO_VAL(EAGAIN, rc);
+
+	for (i = 0; i < buffer_size; i++) {
+		PCUT_ASSERT_INT_EQUALS(i, circ_buf_nfree(&cbuf));
+		PCUT_ASSERT_INT_EQUALS(buffer_size - i, circ_buf_nused(&cbuf));
+		rc = circ_buf_pop(&cbuf, &j);
+		PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+		PCUT_ASSERT_INT_EQUALS(i, j);
+	}
+
+	PCUT_ASSERT_INT_EQUALS(buffer_size, circ_buf_nfree(&cbuf));
+	PCUT_ASSERT_INT_EQUALS(0, circ_buf_nused(&cbuf));
+
+	rc = circ_buf_pop(&cbuf, &j);
+	PCUT_ASSERT_ERRNO_VAL(EAGAIN, rc);
+}
+
+PCUT_EXPORT(circ_buf);
Index: uspace/lib/c/test/fibril/timer.c
===================================================================
--- uspace/lib/c/test/fibril/timer.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/test/fibril/timer.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -27,4 +27,5 @@
  */
 
+#include <async.h>
 #include <fibril_synch.h>
 #include <pcut/pcut.h>
@@ -77,5 +78,5 @@
 
 	fibril_timer_set_locked(t, 100 * 1000 * 1000, test_timeout_fn, &cnt);
-	fibril_usleep(1000);
+	async_usleep(1000);
 	fts = fibril_timer_clear_locked(t);
 	PCUT_ASSERT_INT_EQUALS(fts_active, fts);
@@ -100,5 +101,5 @@
 	cnt = 0;
 	fibril_timer_set(t, 100 * 1000 * 1000, test_timeout_fn, &cnt);
-	fibril_usleep(1000);
+	async_usleep(1000);
 	fts = fibril_timer_clear(t);
 	PCUT_ASSERT_INT_EQUALS(fts_active, fts);
@@ -126,5 +127,5 @@
 	fibril_mutex_unlock(&lock);
 
-	fibril_usleep(1000);
+	async_usleep(1000);
 
 	fibril_mutex_lock(&lock);
Index: uspace/lib/c/test/main.c
===================================================================
--- uspace/lib/c/test/main.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/test/main.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -32,4 +32,5 @@
 PCUT_INIT
 
+PCUT_IMPORT(circ_buf);
 PCUT_IMPORT(fibril_timer);
 PCUT_IMPORT(odict);
Index: uspace/lib/compress/gzip.c
===================================================================
--- uspace/lib/compress/gzip.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/compress/gzip.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -31,6 +31,6 @@
 #include <errno.h>
 #include <mem.h>
-#include <malloc.h>
 #include <byteorder.h>
+#include <stdlib.h>
 #include "gzip.h"
 #include "inflate.h"
Index: uspace/lib/draw/codec/tga.gz.c
===================================================================
--- uspace/lib/draw/codec/tga.gz.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/draw/codec/tga.gz.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,5 +36,5 @@
 #include <errno.h>
 #include <gzip.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include "tga.gz.h"
 #include "tga.h"
Index: uspace/lib/draw/cursor.c
===================================================================
--- uspace/lib/draw/cursor.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/draw/cursor.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -34,5 +34,5 @@
  */
 
-#include <malloc.h>
+#include <stdlib.h>
 
 #include "cursor.h"
Index: uspace/lib/draw/cursor/embedded.c
===================================================================
--- uspace/lib/draw/cursor/embedded.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/draw/cursor/embedded.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -37,5 +37,5 @@
 #include <stddef.h>
 #include <stdint.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 #include "../gfx/cursor-11x18.h"
Index: uspace/lib/draw/drawctx.c
===================================================================
--- uspace/lib/draw/drawctx.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/draw/drawctx.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,5 +36,5 @@
 #include <assert.h>
 #include <adt/list.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 #include "drawctx.h"
Index: uspace/lib/draw/font.c
===================================================================
--- uspace/lib/draw/font.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/draw/font.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,6 +35,6 @@
  */
 
-#include <malloc.h>
 #include <errno.h>
+#include <stdlib.h>
 #include <str.h>
 
Index: uspace/lib/draw/font/bitmap_backend.c
===================================================================
--- uspace/lib/draw/font/bitmap_backend.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/draw/font/bitmap_backend.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,6 +35,6 @@
  */
 
-#include <malloc.h>
 #include <errno.h>
+#include <stdlib.h>
 
 #include "../font.h"
Index: uspace/lib/draw/font/embedded.c
===================================================================
--- uspace/lib/draw/font/embedded.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/draw/font/embedded.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,6 +36,6 @@
 
 #include <stdint.h>
-#include <malloc.h>
 #include <errno.h>
+#include <stdlib.h>
 
 #include "../gfx/font-8x16.h"
Index: uspace/lib/draw/font/pcf.c
===================================================================
--- uspace/lib/draw/font/pcf.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/draw/font/pcf.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,5 +36,4 @@
 #include <stddef.h>
 #include <stdint.h>
-#include <malloc.h>
 #include <errno.h>
 #include <byteorder.h>
@@ -42,4 +41,5 @@
 #include <align.h>
 #include <offset.h>
+#include <stdlib.h>
 
 #include "pcf.h"
Index: uspace/lib/draw/path.c
===================================================================
--- uspace/lib/draw/path.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/draw/path.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,5 +35,5 @@
 
 #include <assert.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 #include "path.h"
Index: uspace/lib/draw/surface.c
===================================================================
--- uspace/lib/draw/surface.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/draw/surface.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,8 +35,8 @@
  */
 
-#include <malloc.h>
 #include <mem.h>
 #include <as.h>
 #include <assert.h>
+#include <stdlib.h>
 #include "surface.h"
 
Index: uspace/lib/drv/Makefile
===================================================================
--- uspace/lib/drv/Makefile	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/drv/Makefile	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -43,5 +43,4 @@
 	generic/remote_hw_res.c \
 	generic/remote_pio_window.c \
-	generic/remote_char_dev.c \
 	generic/remote_nic.c \
 	generic/remote_ieee80211.c \
Index: uspace/lib/drv/generic/dev_iface.c
===================================================================
--- uspace/lib/drv/generic/dev_iface.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/drv/generic/dev_iface.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -42,5 +42,4 @@
 #include "remote_hw_res.h"
 #include "remote_pio_window.h"
-#include "remote_char_dev.h"
 #include "remote_clock_dev.h"
 #include "remote_led_dev.h"
@@ -62,5 +61,4 @@
 		[HW_RES_DEV_IFACE] = &remote_hw_res_iface,
 		[PIO_WINDOW_DEV_IFACE] = &remote_pio_window_iface,
-		[CHAR_DEV_IFACE] = &remote_char_dev_iface,
 		[NIC_DEV_IFACE] = &remote_nic_iface,
 		[IEEE80211_DEV_IFACE] = &remote_ieee80211_iface,
Index: uspace/lib/drv/generic/interrupt.c
===================================================================
--- uspace/lib/drv/generic/interrupt.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/drv/generic/interrupt.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -44,8 +44,9 @@
 
 int register_interrupt_handler(ddf_dev_t *dev, int irq,
-    interrupt_handler_t *handler, const irq_code_t *irq_code)
+    interrupt_handler_t *handler, const irq_code_t *irq_code,
+    cap_handle_t *handle)
 {
 	return async_irq_subscribe(irq, (async_notification_handler_t) handler,
-	    dev, irq_code);
+	    dev, irq_code, handle);
 }
 
Index: uspace/lib/drv/generic/remote_audio_pcm.c
===================================================================
--- uspace/lib/drv/generic/remote_audio_pcm.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/drv/generic/remote_audio_pcm.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -221,18 +221,15 @@
  * @param sess Audio device session.
  * @param cap  Audio device capability.
- * @param val  Place to store queried value.
- *
- * @return Error code.
- */
-int audio_pcm_query_cap(audio_pcm_sess_t *sess, audio_cap_t cap)
-{
-	async_exch_t *exch = async_exchange_begin(sess);
-	sysarg_t value = 0;
+ * @param[out] val  Place to store queried value.
+ *
+ * @return Error code.
+ */
+int audio_pcm_query_cap(audio_pcm_sess_t *sess, audio_cap_t cap, sysarg_t *value)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
 	const int ret = async_req_2_1(exch,
 	    DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE), IPC_M_AUDIO_PCM_QUERY_CAPS,
-	    cap, &value);
-	async_exchange_end(exch);
-	if (ret == EOK)
-		return value;
+	    cap, value);
+	async_exchange_end(exch);
 	return ret;
 }
Index: uspace/lib/drv/include/audio_pcm_iface.h
===================================================================
--- uspace/lib/drv/include/audio_pcm_iface.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/drv/include/audio_pcm_iface.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -83,5 +83,5 @@
 int audio_pcm_test_format(audio_pcm_sess_t *, unsigned *, unsigned *,
     pcm_sample_format_t *);
-int audio_pcm_query_cap(audio_pcm_sess_t *, audio_cap_t);
+int audio_pcm_query_cap(audio_pcm_sess_t *, audio_cap_t, sysarg_t *);
 int audio_pcm_register_event_callback(audio_pcm_sess_t *,
     async_port_handler_t, void *);
Index: uspace/lib/drv/include/ddf/interrupt.h
===================================================================
--- uspace/lib/drv/include/ddf/interrupt.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/drv/include/ddf/interrupt.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -48,8 +48,8 @@
  */
 
-typedef void interrupt_handler_t(ipc_callid_t, ipc_call_t *, ddf_dev_t *);
+typedef void interrupt_handler_t(ipc_call_t *, ddf_dev_t *);
 
 extern int register_interrupt_handler(ddf_dev_t *, int, interrupt_handler_t *,
-    const irq_code_t *);
+    const irq_code_t *, cap_handle_t *);
 extern int unregister_interrupt_handler(ddf_dev_t *, int);
 
Index: uspace/lib/ext4/src/directory.c
===================================================================
--- uspace/lib/ext4/src/directory.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/ext4/src/directory.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -38,6 +38,6 @@
 #include <byteorder.h>
 #include <errno.h>
-#include <malloc.h>
 #include <mem.h>
+#include <stdlib.h>
 #include <str.h>
 #include "ext4/directory.h"
Index: uspace/lib/ext4/src/extent.c
===================================================================
--- uspace/lib/ext4/src/extent.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/ext4/src/extent.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -37,6 +37,6 @@
 #include <byteorder.h>
 #include <errno.h>
-#include <malloc.h>
 #include <mem.h>
+#include <stdlib.h>
 #include "ext4/balloc.h"
 #include "ext4/extent.h"
Index: uspace/lib/ext4/src/ops.c
===================================================================
--- uspace/lib/ext4/src/ops.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/ext4/src/ops.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -42,6 +42,6 @@
 #include <libfs.h>
 #include <macros.h>
-#include <malloc.h>
 #include <mem.h>
+#include <stdlib.h>
 #include <str.h>
 #include <ipc/loc.h>
Index: uspace/lib/ext4/src/superblock.c
===================================================================
--- uspace/lib/ext4/src/superblock.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/ext4/src/superblock.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -40,6 +40,6 @@
 #include <byteorder.h>
 #include <errno.h>
-#include <malloc.h>
 #include <mem.h>
+#include <stdlib.h>
 #include "ext4/superblock.h"
 
Index: uspace/lib/fmtutil/fmtutil.c
===================================================================
--- uspace/lib/fmtutil/fmtutil.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/fmtutil/fmtutil.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -29,6 +29,6 @@
 #include <io/console.h>
 #include <errno.h>
-#include <malloc.h>
 #include <fmtutil.h>
+#include <stdlib.h>
 
 typedef struct {
Index: uspace/lib/fs/libfs.c
===================================================================
--- uspace/lib/fs/libfs.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/fs/libfs.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -656,5 +656,5 @@
 		if (rc == EOK) {
 			aoff64_t size = ops->size_get(cur);
-			async_answer_5(rid, fs_handle, service_id,
+			async_answer_5(rid, EOK, fs_handle,
 			    ops->index_get(cur),
 			    (ops->is_directory(cur) << 16) | last,
@@ -699,5 +699,5 @@
 out1:
 	if (!cur) {
-		async_answer_5(rid, fs_handle, service_id, ops->index_get(par),
+		async_answer_5(rid, EOK, fs_handle, ops->index_get(par),
 		    (ops->is_directory(par) << 16) | last_next,
 		    LOWER32(ops->size_get(par)), UPPER32(ops->size_get(par)));
@@ -705,5 +705,5 @@
 	}
 	
-	async_answer_5(rid, fs_handle, service_id, ops->index_get(cur),
+	async_answer_5(rid, EOK, fs_handle, ops->index_get(cur),
 	    (ops->is_directory(cur) << 16) | last, LOWER32(ops->size_get(cur)),
 	    UPPER32(ops->size_get(cur)));
Index: uspace/lib/graph/graph.c
===================================================================
--- uspace/lib/graph/graph.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/graph/graph.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -38,6 +38,6 @@
 #include <inttypes.h>
 #include <stdio.h>
-#include <malloc.h>
 #include <as.h>
+#include <stdlib.h>
 #include "graph.h"
 
Index: uspace/lib/gui/button.c
===================================================================
--- uspace/lib/gui/button.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/gui/button.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,5 +35,5 @@
 
 #include <str.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <drawctx.h>
 #include <surface.h>
Index: uspace/lib/gui/canvas.c
===================================================================
--- uspace/lib/gui/canvas.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/gui/canvas.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -34,5 +34,5 @@
  */
 
-#include <malloc.h>
+#include <stdlib.h>
 #include <transform.h>
 #include <source.h>
Index: uspace/lib/gui/connection.c
===================================================================
--- uspace/lib/gui/connection.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/gui/connection.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,5 +35,5 @@
 
 #include <mem.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <adt/list.h>
 #include <adt/prodcons.h>
Index: uspace/lib/gui/grid.c
===================================================================
--- uspace/lib/gui/grid.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/gui/grid.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -37,5 +37,5 @@
 #include <assert.h>
 #include <mem.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <surface.h>
 #include "window.h"
Index: uspace/lib/gui/label.c
===================================================================
--- uspace/lib/gui/label.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/gui/label.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,6 +35,6 @@
 
 #include <str.h>
-#include <malloc.h>
 #include <drawctx.h>
+#include <stdlib.h>
 #include <surface.h>
 #include <font/embedded.h>
Index: uspace/lib/gui/minimal.c
===================================================================
--- uspace/lib/gui/minimal.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/gui/minimal.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -34,5 +34,5 @@
  */
 
-#include <malloc.h>
+#include <stdlib.h>
 #include <surface.h>
 
Index: uspace/lib/gui/terminal.c
===================================================================
--- uspace/lib/gui/terminal.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/gui/terminal.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,5 +35,5 @@
 
 #include <errno.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <io/chargrid.h>
 #include <surface.h>
@@ -64,6 +64,6 @@
 static int term_open(con_srvs_t *, con_srv_t *);
 static int term_close(con_srv_t *);
-static int term_read(con_srv_t *, void *, size_t);
-static int term_write(con_srv_t *, void *, size_t);
+static int term_read(con_srv_t *, void *, size_t, size_t *);
+static int term_write(con_srv_t *, void *, size_t, size_t *);
 static void term_sync(con_srv_t *);
 static void term_clear(con_srv_t *);
@@ -386,5 +386,5 @@
 }
 
-static int term_read(con_srv_t *srv, void *buf, size_t size)
+static int term_read(con_srv_t *srv, void *buf, size_t size, size_t *nread)
 {
 	terminal_t *term = srv_to_terminal(srv);
@@ -431,5 +431,6 @@
 	}
 	
-	return size;
+	*nread = size;
+	return EOK;
 }
 
@@ -462,5 +463,5 @@
 }
 
-static int term_write(con_srv_t *srv, void *data, size_t size)
+static int term_write(con_srv_t *srv, void *data, size_t size, size_t *nwritten)
 {
 	terminal_t *term = srv_to_terminal(srv);
@@ -470,5 +471,6 @@
 		term_write_char(term, str_decode(data, &off, size));
 	
-	return size;
+	*nwritten = size;
+	return EOK;
 }
 
Index: uspace/lib/gui/window.c
===================================================================
--- uspace/lib/gui/window.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/gui/window.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -40,5 +40,5 @@
 
 #include <as.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <str.h>
 
